(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
	typeof define === 'function' && define.amd ? define('ngx-component-outlet', ['exports', '@angular/core'], factory) :
	(factory((global['ngx-component-outlet'] = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

var PRIVATE_PREFIX = '__ngxOnChanges_';
function onChangesWrapper(delegateHook) {
    return function () {
        var simpleChanges = this[PRIVATE_PREFIX];
        if (simpleChanges != null) {
            if (this.ngOnChanges) {
                this.ngOnChanges(simpleChanges);
            }
            this[PRIVATE_PREFIX] = null;
        }
        if (delegateHook) {
            delegateHook.apply(this);
        }
    };
}
function markForCheckWrapper(delegateHook, cd) {
    return function () {
        if (delegateHook) {
            delegateHook.apply(this);
        }
        if (cd) {
            cd.markForCheck();
        }
    };
}
function hasProperty(context, name) {
    if (context.hasOwnProperty(name)) {
        return true;
    }
    var prototype = Object.getPrototypeOf(context);
    if (prototype) {
        return hasProperty(prototype, name);
    }
    return false;
}
function getPropertyDescriptor(context, name) {
    if (context.hasOwnProperty(name)) {
        return Object.getOwnPropertyDescriptor(context, name);
    }
    var prototype = Object.getPrototypeOf(context);
    if (prototype) {
        return getPropertyDescriptor(prototype, name);
    }
    return void 0;
}
var OnInitOnlyComponent = /** @class */ (function () {
    function OnInitOnlyComponent() {
    }
    OnInitOnlyComponent.prototype.ngOnInit = function () { };
    return OnInitOnlyComponent;
}());
OnInitOnlyComponent.decorators = [
    { type: core.Component, args: [{ selector: 'ngx-component-outlet-on-init-only', template: '' },] },
];
var DoCheckOnlyComponent = /** @class */ (function () {
    function DoCheckOnlyComponent() {
    }
    DoCheckOnlyComponent.prototype.ngDoCheck = function () { };
    return DoCheckOnlyComponent;
}());
DoCheckOnlyComponent.decorators = [
    { type: core.Component, args: [{ selector: 'ngx-component-outlet-do-check-only', template: '' },] },
];
var OnInitAndDoCheckComponent = /** @class */ (function () {
    function OnInitAndDoCheckComponent() {
    }
    OnInitAndDoCheckComponent.prototype.ngOnInit = function () { };
    OnInitAndDoCheckComponent.prototype.ngDoCheck = function () { };
    return OnInitAndDoCheckComponent;
}());
OnInitAndDoCheckComponent.decorators = [
    { type: core.Component, args: [{ selector: 'ngx-component-outlet-on-init-do-check', template: '' },] },
];
var NgxComponentOutletAdapterRef = /** @class */ (function () {
    function NgxComponentOutletAdapterRef(config) {
        this.attachedOutputs = [];
        this.defaultDescriptors = [];
        this.componentFactory = config.componentFactory;
        this.componentRef = config.componentRef;
        this.context = config.context;
        this.onInitComponentRef = config.onInitComponentRef || (this.componentRef);
        this.doCheckComponentRef = config.doCheckComponentRef || (this.componentRef);
        this.changeDetectorRef = this.componentRef.injector.get(core.ChangeDetectorRef, this.componentRef.changeDetectorRef);
        this.attachInputs();
        this.attachLifecycle();
        this.attachOutputs();
    }
    NgxComponentOutletAdapterRef.prototype.dispose = function () {
        this.disposeOutputs();
        this.disposeInputs();
        if (this.componentRef) {
            this.componentRef.destroy();
            this.componentRef = null;
        }
        if (this.onInitComponentRef) {
            this.onInitComponentRef.destroy();
            this.onInitComponentRef = null;
        }
        if (this.doCheckComponentRef) {
            this.doCheckComponentRef.destroy();
            this.doCheckComponentRef = null;
        }
    };
    NgxComponentOutletAdapterRef.prototype.attachInputs = function () {
        var _this = this;
        var inputs = this.componentFactory.inputs;
        this.defaultDescriptors = inputs.map(function (property) {
            var defaultDescriptor = getPropertyDescriptor(_this.context, property.templateName);
            _this.attachInput(_this.context, _this.componentRef.instance, property, defaultDescriptor);
            return (Object.assign({}, property, { defaultDescriptor: defaultDescriptor }));
        });
    };
    NgxComponentOutletAdapterRef.prototype.attachInput = function (context, instance, _a, defaultDescriptor) {
        var propName = _a.propName, templateName = _a.templateName;
        var defaultValue = context[templateName];
        Object.defineProperty(context, templateName, {
            get: function () {
                if (defaultDescriptor && defaultDescriptor.get) {
                    return defaultDescriptor.get.call(context);
                }
                else {
                    return instance[propName];
                }
            },
            set: function (value) {
                var simpleChanges = instance[PRIVATE_PREFIX];
                if (simpleChanges == null) {
                    simpleChanges = instance[PRIVATE_PREFIX] = {};
                }
                var isFirstChange = !(instance[PRIVATE_PREFIX + "_" + templateName]);
                instance[PRIVATE_PREFIX + "_" + templateName] = true;
                simpleChanges[templateName] = new core.SimpleChange(instance[propName], value, isFirstChange);
                if (defaultDescriptor && defaultDescriptor.set) {
                    defaultDescriptor.set.call(context, value);
                }
                instance[propName] = value;
            }
        });
        if (typeof defaultValue !== 'undefined') {
            context[templateName] = defaultValue;
        }
    };
    NgxComponentOutletAdapterRef.prototype.attachLifecycle = function () {
        var instance = (this.componentRef.instance);
        if (hasProperty(this.componentRef.componentType.prototype, 'ngOnChanges')) {
            var markForCheckWrapped = markForCheckWrapper(instance.ngDoCheck, this.changeDetectorRef).bind(instance);
            this.onInitComponentRef.instance.ngOnInit = onChangesWrapper(instance.ngOnInit).bind(instance);
            this.doCheckComponentRef.instance.ngDoCheck = onChangesWrapper(markForCheckWrapped).bind(instance);
        }
        else {
            this.doCheckComponentRef.instance.ngDoCheck = markForCheckWrapper(instance.ngDoCheck, this.changeDetectorRef).bind(instance);
        }
    };
    NgxComponentOutletAdapterRef.prototype.disposeInputs = function () {
        var _this = this;
        var instance = (this.componentRef.instance);
        this.defaultDescriptors.forEach(function (_a) {
            var propName = _a.propName, templateName = _a.templateName, defaultDescriptor = _a.defaultDescriptor;
            if (defaultDescriptor) {
                if (defaultDescriptor.writable) {
                    defaultDescriptor.value = instance[propName];
                }
                Object.defineProperty(_this.context, templateName, defaultDescriptor);
                if (defaultDescriptor.set) {
                    _this.context[templateName] = instance[propName];
                }
            }
            else {
                delete _this.context[templateName];
                _this.context[templateName] = instance[propName];
            }
        });
    };
    NgxComponentOutletAdapterRef.prototype.attachOutputs = function () {
        var _this = this;
        var availableOutputs = this.componentFactory.outputs.filter(function (property) { return _this.context.hasOwnProperty(property.templateName); });
        this.attachedOutputs = availableOutputs.map(function (property) { return _this.componentRef.instance[property.propName].subscribe(_this.context[property.templateName]); });
    };
    NgxComponentOutletAdapterRef.prototype.disposeOutputs = function () {
        this.attachedOutputs.splice(0).forEach(function (subscription) { return subscription.unsubscribe(); });
    };
    return NgxComponentOutletAdapterRef;
}());
var LifecycleStrategyType = {
    Default: 0,
    OnInitOnly: 1,
    DoCheckOnly: 2,
    OnInitAndDoCheck: 3,
};
LifecycleStrategyType[LifecycleStrategyType.Default] = "Default";
LifecycleStrategyType[LifecycleStrategyType.OnInitOnly] = "OnInitOnly";
LifecycleStrategyType[LifecycleStrategyType.DoCheckOnly] = "DoCheckOnly";
LifecycleStrategyType[LifecycleStrategyType.OnInitAndDoCheck] = "OnInitAndDoCheck";
var STRATEGY_CONFIG = (_a = {}, _a[LifecycleStrategyType.Default] = {}, _a[LifecycleStrategyType.OnInitOnly] = {
        componentType: OnInitOnlyComponent,
        useOnInitComponent: true
    }, _a[LifecycleStrategyType.DoCheckOnly] = {
        componentType: DoCheckOnlyComponent,
        useDoCheckComponent: true
    }, _a[LifecycleStrategyType.OnInitAndDoCheck] = {
        componentType: OnInitAndDoCheckComponent,
        useOnInitComponent: true,
        useDoCheckComponent: true
    }, _a);
var NgxComponentOutletAdapterBuilderStrategy = /** @class */ (function () {
    function NgxComponentOutletAdapterBuilderStrategy(componentFactoryResolver, config) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.config = config;
    }
    NgxComponentOutletAdapterBuilderStrategy.prototype.create = function (componentFactory, componentRef, viewContainerRef, context) {
        var _a = this.createFeatureComponents(viewContainerRef), onInitComponentRef = _a.onInitComponentRef, doCheckComponentRef = _a.doCheckComponentRef;
        return this.createAdapterRef({
            componentFactory: componentFactory, componentRef: componentRef, context: context,
            onInitComponentRef: onInitComponentRef, doCheckComponentRef: doCheckComponentRef
        });
    };
    NgxComponentOutletAdapterBuilderStrategy.prototype.createFeatureComponents = function (viewContainerRef) {
        if (!this.config.componentType) {
            return { onInitComponentRef: null, doCheckComponentRef: null };
        }
        var featureComponentFactory = this.componentFactoryResolver.resolveComponentFactory(this.config.componentType);
        var featureComponentRef = viewContainerRef.createComponent(featureComponentFactory, viewContainerRef.length);
        return {
            onInitComponentRef: this.config.useOnInitComponent ? featureComponentRef : null,
            doCheckComponentRef: this.config.useDoCheckComponent ? featureComponentRef : null
        };
    };
    NgxComponentOutletAdapterBuilderStrategy.prototype.createAdapterRef = function (config) {
        return new NgxComponentOutletAdapterRef(config);
    };
    return NgxComponentOutletAdapterBuilderStrategy;
}());
var NgxComponentOutletAdapterBuilderStrategyResolver = /** @class */ (function () {
    function NgxComponentOutletAdapterBuilderStrategyResolver(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
    }
    NgxComponentOutletAdapterBuilderStrategyResolver.prototype.resolve = function (component) {
        var type = this.getStrategyType(component);
        return new NgxComponentOutletAdapterBuilderStrategy(this.componentFactoryResolver, STRATEGY_CONFIG[type]);
    };
    NgxComponentOutletAdapterBuilderStrategyResolver.prototype.getStrategyType = function (component) {
        var hasNgOnInit = hasProperty(component.prototype, 'ngOnInit');
        var hasNgDoCheck = hasProperty(component.prototype, 'ngDoCheck');
        var hasNgOnChanges = hasProperty(component.prototype, 'ngOnChanges');
        if (hasNgOnChanges && !hasNgOnInit && !hasNgDoCheck) {
            return LifecycleStrategyType.OnInitAndDoCheck;
        }
        if (hasNgOnChanges && !hasNgOnInit) {
            return LifecycleStrategyType.OnInitOnly;
        }
        if (!hasNgDoCheck) {
            return LifecycleStrategyType.DoCheckOnly;
        }
        return LifecycleStrategyType.Default;
    };
    return NgxComponentOutletAdapterBuilderStrategyResolver;
}());
NgxComponentOutletAdapterBuilderStrategyResolver.decorators = [
    { type: core.Injectable },
];
NgxComponentOutletAdapterBuilderStrategyResolver.ctorParameters = function () { return [
    { type: core.ComponentFactoryResolver, },
]; };
var NgxComponentOutletAdapterBuilder = /** @class */ (function () {
    function NgxComponentOutletAdapterBuilder(adapterBuilderStrategyResolver) {
        this.adapterBuilderStrategyResolver = adapterBuilderStrategyResolver;
    }
    NgxComponentOutletAdapterBuilder.prototype.create = function (componentType, viewContainerRef, injector, projectableNodes, context, componentFactoryResolver) {
        var componentFactory = componentFactoryResolver.resolveComponentFactory(componentType);
        var componentRef = viewContainerRef.createComponent(componentFactory, viewContainerRef.length, injector, projectableNodes);
        var strategy = this.adapterBuilderStrategyResolver.resolve(componentType);
        return strategy.create(componentFactory, componentRef, viewContainerRef, context);
    };
    return NgxComponentOutletAdapterBuilder;
}());
NgxComponentOutletAdapterBuilder.decorators = [
    { type: core.Injectable },
];
NgxComponentOutletAdapterBuilder.ctorParameters = function () { return [
    { type: NgxComponentOutletAdapterBuilderStrategyResolver, },
]; };
var NgxComponentOutlet = /** @class */ (function () {
    function NgxComponentOutlet(_componentFactoryResolver, viewContainerRef, builder) {
        this._componentFactoryResolver = _componentFactoryResolver;
        this.viewContainerRef = viewContainerRef;
        this.builder = builder;
        this.ngxComponentOutletActivate = new core.EventEmitter();
        this.ngxComponentOutletDeactivate = new core.EventEmitter();
    }
    Object.defineProperty(NgxComponentOutlet.prototype, "componentFactoryResolver", {
        get: function () {
            return this._ngModuleRef ? this._ngModuleRef.componentFactoryResolver : this._componentFactoryResolver;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxComponentOutlet.prototype, "context", {
        get: function () {
            var context = (this.injector.get(core.ChangeDetectorRef)).context;
            return context;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxComponentOutlet.prototype, "injector", {
        get: function () {
            return this.ngxComponentOutletInjector || this.viewContainerRef.injector;
        },
        enumerable: true,
        configurable: true
    });
    NgxComponentOutlet.prototype.ngOnChanges = function (changes) {
        if (changes["ngxComponentOutlet"]) {
            if (changes["ngxComponentOutletNgModuleFactory"]) {
                this.destroyNgModuleRef();
                this.createNgModuleRef();
            }
            this.destroyAdapterRef();
            this.createAdapterRef();
        }
    };
    NgxComponentOutlet.prototype.ngOnDestroy = function () {
        this.destroyAdapterRef();
        this.destroyNgModuleRef();
    };
    NgxComponentOutlet.prototype.createAdapterRef = function () {
        if (this.ngxComponentOutlet) {
            this._adapterRef = this.builder.create(this.ngxComponentOutlet, this.viewContainerRef, this.injector, this.ngxComponentOutletContent, this.context, this.componentFactoryResolver);
            this.ngxComponentOutletActivate.emit(this._adapterRef.componentRef.instance);
        }
    };
    NgxComponentOutlet.prototype.destroyAdapterRef = function () {
        if (this._adapterRef) {
            this.ngxComponentOutletDeactivate.emit(this._adapterRef.componentRef.instance);
            this._adapterRef.dispose();
            this._adapterRef = null;
        }
    };
    NgxComponentOutlet.prototype.createNgModuleRef = function () {
        if (this.ngxComponentOutletNgModuleFactory) {
            this._ngModuleRef = this.ngxComponentOutletNgModuleFactory.create(this.injector);
        }
    };
    NgxComponentOutlet.prototype.destroyNgModuleRef = function () {
        if (this._ngModuleRef) {
            this._ngModuleRef.destroy();
            this._ngModuleRef = null;
        }
    };
    return NgxComponentOutlet;
}());
NgxComponentOutlet.decorators = [
    { type: core.Directive, args: [{ selector: '[ngxComponentOutlet]' },] },
];
NgxComponentOutlet.ctorParameters = function () { return [
    { type: core.ComponentFactoryResolver, },
    { type: core.ViewContainerRef, },
    { type: NgxComponentOutletAdapterBuilder, },
]; };
NgxComponentOutlet.propDecorators = {
    "ngxComponentOutlet": [{ type: core.Input },],
    "ngxComponentOutletInjector": [{ type: core.Input },],
    "ngxComponentOutletContent": [{ type: core.Input },],
    "ngxComponentOutletNgModuleFactory": [{ type: core.Input },],
    "ngxComponentOutletActivate": [{ type: core.Output },],
    "ngxComponentOutletDeactivate": [{ type: core.Output },],
};
var NgxComponentOutletResolvePipe = /** @class */ (function () {
    function NgxComponentOutletResolvePipe() {
    }
    NgxComponentOutletResolvePipe.prototype.transform = function (value, resolver) {
        return resolver.resolve(value);
    };
    return NgxComponentOutletResolvePipe;
}());
NgxComponentOutletResolvePipe.decorators = [
    { type: core.Pipe, args: [{ name: 'resolve', pure: true },] },
];
var NgxComponentOutletModule = /** @class */ (function () {
    function NgxComponentOutletModule() {
    }
    NgxComponentOutletModule.forRoot = function () {
        return {
            ngModule: NgxComponentOutletModule,
            providers: [
                NgxComponentOutletAdapterBuilder,
                NgxComponentOutletAdapterBuilderStrategyResolver
            ]
        };
    };
    NgxComponentOutletModule.forChild = function () {
        return {
            ngModule: NgxComponentOutletModule
        };
    };
    return NgxComponentOutletModule;
}());
NgxComponentOutletModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    NgxComponentOutlet,
                    NgxComponentOutletResolvePipe,
                    OnInitOnlyComponent,
                    DoCheckOnlyComponent,
                    OnInitAndDoCheckComponent
                ],
                entryComponents: [
                    OnInitOnlyComponent,
                    DoCheckOnlyComponent,
                    OnInitAndDoCheckComponent
                ],
                exports: [
                    NgxComponentOutlet,
                    NgxComponentOutletResolvePipe
                ]
            },] },
];
var _a;

exports.NgxComponentOutletModule = NgxComponentOutletModule;
exports.ɵb = NgxComponentOutletAdapterBuilder;
exports.ɵf = DoCheckOnlyComponent;
exports.ɵg = OnInitAndDoCheckComponent;
exports.ɵe = OnInitOnlyComponent;
exports.ɵc = NgxComponentOutletAdapterBuilderStrategyResolver;
exports.ɵa = NgxComponentOutlet;
exports.ɵd = NgxComponentOutletResolvePipe;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-component-outlet.umd.js.map
