import { ComponentFactory, ComponentFactoryResolver, ComponentRef, Type, ViewContainerRef } from '@angular/core';
import { LifecycleComponent, NgxComponentOutletAdapterRef } from './adapter-ref';
export interface StrategyConfig {
    componentType?: Type<LifecycleComponent>;
    useOnInitComponent?: boolean;
    useDoCheckComponent?: boolean;
}
export declare class NgxComponentOutletAdapterBuilderStrategy {
    private componentFactoryResolver;
    private config;
    constructor(componentFactoryResolver: ComponentFactoryResolver, config: StrategyConfig);
    create<TComponent>(componentFactory: ComponentFactory<TComponent>, componentRef: ComponentRef<TComponent>, viewContainerRef: ViewContainerRef, context: TComponent): NgxComponentOutletAdapterRef<TComponent>;
    private createFeatureComponents(viewContainerRef);
    private createAdapterRef<TComponent>(config);
}
export declare class NgxComponentOutletAdapterBuilderStrategyResolver {
    private componentFactoryResolver;
    constructor(componentFactoryResolver: ComponentFactoryResolver);
    resolve(component: Type<any>): NgxComponentOutletAdapterBuilderStrategy;
    private getStrategyType(component);
}
